#include <sta/rtos/mutex.hpp>

#include <sta/debug/assert.hpp>


namespace sta
{
	RtosMutex::RtosMutex(osMutexId_t handle)
		: handle_{handle}
	{}

	RtosMutex::RtosMutex(const char* name)
	{
		osMutexAttr_t attribs = { .name = name};
		handle_ = osMutexNew(&attribs);

		STA_ASSERT(handle_ != NULL);
	}

	void RtosMutex::acquire()
	{
		osMutexAcquire(handle_, osWaitForever);
	}

	void RtosMutex::release()
	{
		osMutexRelease(handle_);
	}
} // namespace sta
